﻿using Ryujinx.Common.Pools;
using Ryujinx.Graphics.GAL.Multithreading.Model;
using Ryujinx.Graphics.GAL.Multithreading.Resources;
using System;

namespace Ryujinx.Graphics.GAL.Multithreading.Commands.Texture
{
    struct TextureSetDataCommand : IGALCommand
    {
        public CommandType CommandType => CommandType.TextureSetData;
        private TableRef<ThreadedTexture> _texture;
        private TableRef<PooledBuffer<byte>> _data;

        public void Set(TableRef<ThreadedTexture> texture, TableRef<PooledBuffer<byte>> data)
        {
            _texture = texture;
            _data = data;
        }

        public static void Run(ref TextureSetDataCommand command, ThreadedRenderer threaded, IRenderer renderer)
        {
            ThreadedTexture texture = command._texture.Get(threaded);
            using (PooledBuffer<byte> pooledData = command._data.Get(threaded))
            {
                texture.Base.SetData(pooledData.AsReadOnlySpan);
            }
        }
    }
}
